/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.staat;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.staat.boundary.AbstractStaatSearchParameters;
import de.ivu.elect.business.staat.boundary.StaatChangeEvent;
import de.ivu.elect.business.staat.boundary.StaatConversationStore;
import de.ivu.elect.business.staat.boundary.StaatExtendedDAO;
import de.ivu.elect.business.staat.boundary.StaatSearch;
import de.ivu.elect.business.staat.boundary.StaatSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.staat.entity.Staat;
import de.ivu.elect.business.staat.entity.StaatMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractStaatSearchView.COMPONENT_NAME)
@View(viewId = AbstractStaatSearchView.VIEW_ID, useCase = UseCasePermission.STAAT_SEARCH)
public abstract class AbstractStaatSearchView extends AbstractElectSearchView<Staat> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "staatSearchView";
  
  public static final String VIEW_ID = "/staat/staat-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractStaatSearchView requestHandler;

  @Inject
  private transient StaatExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(StaatConversationStore.class)
  protected transient StaatConversationStore conversationStore;

  @Inject
  protected transient StaatSearch search;

  @Inject
  @ConversationGroup(AbstractStaatSearchParameters.class)
  protected transient StaatSearchParameters searchParameters;

  @Inject
  protected transient StaatMeta entityMeta;

  public AbstractStaatSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Staat getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Staat entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public StaatSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Staat> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Staat> create();
  }

  @Override
  public List<Staat> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Staat> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onStaatChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) StaatChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  //  Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractStaatSearchView {

    @View
    @Inject
    private transient Instance<AbstractStaatSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractStaatSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
